using System;
using AIT.Portrait.ChannelAdapters;
using Impendium.Web.UI;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;

namespace Impendium.Web.SyncfusionPage
{
	/// <summary>
	/// Summary description for homepage.
	/// </summary>
	public class GlobalHomePage : WebPage
	{
		#region Page controls

		protected System.Web.UI.HtmlControls.HtmlForm PageForm;
		protected AIT.Portrait.Web.UI.WebControls.DropDownList SearchFilter;
		protected Syncfusion.Web.UI.WebControls.Grid.Grouping.GridGroupingControl ClaimsGrid;

		#endregion

		private const string searchUIE = "ICE_ClaimsSearch";
		protected AIT.Portrait.Web.UI.WebControls.Label LabelInfo;
		private string claimsXml = string.Empty;

		override protected void Page_Init(object sender, System.EventArgs e)
		{
			GetClaimsData();

			// bind data to grid
			ClaimsGrid.DataBind();
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!this.IsPostBack)
			{
				// Override this function if a custom initialisation is required
				Initialise();

				Navigationbar.Initialise( this, string.Empty );
				base.ExecuteElementRequests();
				Navigationbar.PostInitialise( this );

				SearchFilter.SelectedValue = GetSessionData( "SearchFilterName", SessionDataSource.GlobalContext ).ToString();
			}
		}

		private void ClaimsGrid_SelectedRecordsChanged(object sender, Syncfusion.Grouping.SelectedRecordsChangedEventArgs e)
		{
			int x = ClaimsGrid.Table.Records.Count;
		}

		private void SearchFilter_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Set the global
			SetSessionData( "SearchFilterName", Request[SearchFilter.ID], SessionDataSource.GlobalContext );

			// Re-initialise the page (no need to retrieve the filters again)
			SearchFilter.RequestName = string.Empty;
			Initialise();

			//GetClaimsData();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
			this.EnableViewState = true;
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.SearchFilter.SelectedIndexChanged += new System.EventHandler(this.SearchFilter_SelectedIndexChanged);
			this.ClaimsGrid.SelectedRecordsChanged += new Syncfusion.Grouping.SelectedRecordsChangedEventHandler(this.ClaimsGrid_SelectedRecordsChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void GetClaimsData()
		{
			Adapter.SetElementRequest( searchUIE );
			Adapter.SetElementRequestInputSource( searchUIE, "FilterName", SessionDataSource.GlobalContext, "SearchFilterName" );
			Adapter.SetElementRequestInputSource( searchUIE, "MaxEntries", SessionDataSource.GlobalContext, "MaxEntries" );
			Adapter.ExecuteElementRequests();

			//GridHelper.PopulateGrid( ref ClaimsGrid, Adapter.GetElementData( searchUIE ) );
			ClaimsGrid.DataSource = new GridDataTable( Adapter.GetElementData( searchUIE ) );

			// hidden columns
			ClaimsGrid.TableDescriptor.Columns.FindByMappingName("CONTRACT_ID").FieldDescriptor.Hide = true;
			ClaimsGrid.TableDescriptor.Columns.FindByMappingName("KNOWN_AS").FieldDescriptor.Hide = true;
			ClaimsGrid.TableDescriptor.Columns.FindByMappingName("CounterpartyID").FieldDescriptor.Hide = true;
			ClaimsGrid.TableDescriptor.Columns.FindByMappingName("LegalEntityID").FieldDescriptor.Hide = true;

			// columns to filter
			//ClaimsGrid.TopLevelGroupOptions.ShowFilterBar = true;
			//ClaimsGrid.TableDescriptor.Columns.FindByMappingName("CounterpartyName").AllowFilter = true;

			// columns to sort
			//ClaimsGrid.TableDescriptor.SortedColumns.Add( "CounterpartyName" );

			// freeze top row when scrolling
			ClaimsGrid.FrozenRows = 3;

			// set primary key
			ClaimsGrid.TableDescriptor.PrimaryKeyColumns.Add("CONTRACT_ID");

			ClaimsGrid.TableDescriptor.UnboundFields.Add("S");

			System.Web.UI.WebControls.CheckBox box = new System.Web.UI.WebControls.CheckBox();
			box.ID = "CheckBox1";
			box.EnableViewState = false;
			box.AutoPostBack = false;
			box.Attributes["onClick"] = "ChkOnClick(event);";
			box.CheckedChanged +=new EventHandler(CheckBox1_CheckedChanged);

			GridColumnDescriptor col = new GridColumnDescriptor();
			col.ItemTemplate = (System.Web.UI.ITemplate) box;
			col.AllowGroupByColumn = false;
			col.MappingName = "S";
			col.HeaderText = " ";
			col.Width = 10;
			col.AllowDropDownCell = false;

			ClaimsGrid.TableDescriptor.Columns.Add( col );
			/*
			<sfwg:GridColumnDescriptor AllowGroupByColumn="False" MappingName="S" HeaderText=" " Width="10" AllowDropDownCell="False">
			<ItemTemplate>
			<asp:CheckBox id="CheckBox1" EnableViewState="False" runat="server" AutoPostBack="False" onClick="ChkOnClick(event);"
			OnCheckedChanged="CheckBox1_CheckedChanged"></asp:CheckBox>
			</ItemTemplate>
			</sfwg:GridColumnDescriptor>
			*/
		}

		protected void CheckBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			LabelInfo.Text = "click";
			System.Web.UI.WebControls.CheckBox checkbox1 = (System.Web.UI.WebControls.CheckBox)sender;
			GridRow gridrow = (GridRow)checkbox1.Parent.Parent;
			string catId = gridrow.Record.GetValue("CONTRACT_ID").ToString();
			if (checkbox1 != null)
			{
				if (checkbox1.Checked == true)
				{
					Trace.Write(catId);
					LabelInfo.Text = "Customer <B> " + catId + "</B> Checked <br>";
				}
			} 
		}
	}
}